%define name		tomcat4
%define full_name	jakarta-%{name}
%define version		4.1.24
%define majversion	4.1
%define rpmrelease	2
%define javadir		%{_datadir}/java
%define javadocdir	%{_datadir}/javadoc
%define section		free

%define use_fhs		1

# Temporary workaround for RPM 4.1, all files are not packaged.
# (%{homedir}/*.txt, %{tempdir}/*.txt)
%define _unpackaged_files_terminate_build 0

# choose dist mode :
# light  : for JDK 1.4, ie no need for XML parser, jdbc-stdext...
# full   : include everything
# strict : follow rpm policies, requires externals packages

%define use_dist	strict

%define extjars		bin/commons-daemon.jar common/endorsed/jaxp_parser_impl.jar common/endorsed/xml-commons-apis.jar common/lib/activation.jar common/lib/ant.jar common/lib/commons-collections.jar common/lib/commons-dbcp.jar common/lib/commons-logging-api.jar common/lib/commons-pool.jar common/lib/jdbc-stdext-2.0.jar common/lib/jndi.jar common/lib/jta.jar common/lib/servletapi4.jar server/lib/commons-beanutils.jar server/lib/commons-fileupload.jar server/lib/commons-digester.jar server/lib/commons-logging.jar server/lib/commons-modeler.jar server/lib/jaas.jar server/lib/mx4j-jmx.jar server/lib/regexp-1.2.jar 

%define admjars    server/webapps/admin/WEB-INF/lib/struts.jar

%define mailjars   common/lib/mailapi.jar common/lib/pop.jar common/lib/smtp.jar common/lib/imap.jar

%if %{use_dist} == light
%define release    	le.%{rpmrelease}jpp
%endif

%if %{use_dist} == full
%define release    	full.%{rpmrelease}jpp
%endif

%if %{use_dist} == strict
%define release    	%{rpmrelease}jpp
%endif

%define javadir    		%{_datadir}/java
%define javadocdir 		%{_datadir}/javadoc
%define summary    		Apache Servlet/JSP Engine, RI for Servlet 2.3/JSP 1.2 API
%define license    		Apache Software License
%define vendor     		JPackage Project
%define distribution   	JPackage
%define homedir 		%{_var}/tomcat4
%define jname       	jasper4
%define tcuid       	91

%define packname 		jakarta-tomcat-%{version}
%define packdname 		jakarta-tomcat-%{version}-src
%define jpackdname      jakarta-tomcat-connectors-%{version}-src

%if %{use_fhs}

%define sconfdir        %{_sysconfdir}/%{name}
%define bindir          %{homedir}/bin
%define commondir       %{homedir}/common
%define confdir         %{sconfdir}
%define logdir          %{_var}/log/%{name}
%define servdir         %{homedir}/server
%define shareddir		%{homedir}/shared
%define tempdir         %{_var}/cache/%{name}/temp
%define workdir         %{_var}/cache/%{name}/work
%define appdir          %{homedir}/webapps

%else

%define sconfdir        %{_sysconfdir}/%{name}
%define bindir          %{homedir}/bin
%define commondir       %{homedir}/common
%define confdir         %{homedir}/conf
%define logdir          %{homedir}/logs
%define servdir         %{homedir}/server
%define shareddir       %{homedir}/shared
%define tempdir         %{homedir}/temp
%define workdir         %{homedir}/work
%define appdir          %{homedir}/webapps

%endif

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
License:       	%{license}
Vendor:        	%{vendor}
Distribution:  	%{distribution}
Group: 			Networking/Daemons
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source: 		http://jakarta.apache.org/builds/jakarta-tomcat-4.0/release/v%{version}/src/%{packdname}.tar.gz
Source1:       	http://jakarta.apache.org/builds/jakarta-tomcat-4.0/release/v%{version}/src/%{jpackdname}.tar.gz
Source2:		mod_jk.jpeg
Source3:       	TOMCAT4.README.RPM
Source4: 		tomcat4-%{majversion}.init
Source5:       	tomcat4-%{majversion}.conf
Source6:       	tomcat4-%{majversion}.wrapper
Source7:       	jasper4-%{majversion}.wrapper
Source8:       	%{name}-%{majversion}.logrotate
Patch:			tomcat4-%{version}.patch
BuildRoot: 		/var/tmp/%{name}-root-%{version}

%if %{use_dist} == light
Requires:      	jaxp_parser_impl, xml-commons-apis
%endif

%if %{use_dist} == strict
Requires:		ant >= 1.5
Requires:		jakarta-commons-beanutils >= 1.4.1, jakarta-commons-collections >= 2.0
Requires:		jakarta-commons-daemon, jakarta-commons-dbcp, jakarta-commons-digester >= 1.3
Requires:		jakarta-commons-modeler, jakarta-commons-pool >= 1.0.1
Requires:		jakarta-commons-logging >= 1.0.1, jakarta-commons-fileupload >= 1.0
Requires:		jaas, jaf >= 1.0.1, javamail >= 1.3, jdbc-stdext >= 2.0
Requires:		jndi >= 1.2.1, jta >= 1.0.1a, jaxp_parser_impl
Requires:		mx4j >= 1.1.1, regexp = 1.2, servletapi4 >= 4.0.4, tyrex = 1.0, xml-commons-apis
%endif

BuildRequires:	ant >= 1.5, ant-optional >= 1.5
BuildRequires: 	jakarta-commons-beanutils, jakarta-commons-collections >= 2.0
BuildRequires:  jakarta-commons-daemon, jakarta-commons-dbcp, jakarta-commons-digester >= 1.3
BuildRequires: 	jakarta-commons-logging >= 1.0.1, jakarta-commons-fileupload >= 1.0
BuildRequires: 	jakarta-commons-modeler, jakarta-commons-pool >= 1.0.1
BuildRequires:	jaas, jaf >= 1.0.1, javamail >= 1.3, jdbc-stdext >= 2.0
BuildRequires:	jndi >= 1.2.1, jsse >= 1.0.2, jta >= 1.0.1a
BuildRequires:	log4j >= 1.2.3, junit >= 3.7, mx4j >= 1.1.1
BuildRequires:  regexp = 1.2, puretls, servletapi4 >= 4.0.4, servletapi4-javadoc >= 4.0.4
BuildRequires:	struts >= 1.0.2, tyrex = 1.0, jaxp_parser_impl, xml-commons-apis

%description
Server that conforms to the Servlet 2.3 and JSP 1.2 
specifications from Java Software.


Develop Web applications in Java.

%package webapps
Group:      System Environment/Applications
Requires:   %{name}
Summary:    Web Applications for tomcat

%description webapps
Web Applications for tomcat

%package admin-webapps
Group:      System Environment/Applications
Requires:   %{name}
%if %{use_dist} == strict
Requires:	struts >= 1.0.2
%endif
Summary:    Admin Web Applications for tomcat

%description admin-webapps
Admin Web Applications for tomcat

%prep
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0
%setup -q -T -D -a 1

cd %{packdname}
%patch

%build
export CLASSPATH=%{javadir}/xml-commons-apis.jar:%{javadir}/xalan-j2.jar:%{javadir}/servletapi4.jar

# remove all present jars in tc4/lib
rm -f %{packdname}/lib/*.jar

# remove all present jars in jtc/lib
rm -f %{jpackdname}/lib/*.jar

# build tomcat 4
cd %{packdname}

cat >> build.properties <<EOBP
ant.jar=%{javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-connectors-%{version}-src/
jasper.home=./jasper
commons-beanutils.jar=%{javadir}/commons-beanutils.jar
commons-fileupload.jar=%{javadir}/commons-fileupload.jar
commons-collections.jar=%{javadir}/commons-collections.jar
commons-daemon.jar=%{javadir}/commons-daemon.jar
commons-dbcp.jar=%{javadir}/commons-dbcp.jar
commons-digester.jar=%{javadir}/commons-digester.jar
commons-logging.jar=%{javadir}/commons-logging.jar
commons-logging-api.jar=%{javadir}/commons-logging-api.jar
commons-modeler.jar=%{javadir}/commons-modeler.jar
commons-pool.jar=%{javadir}/commons-pool.jar
jcert.jar=%{javadir}/jsse/jcert.jar
jnet.jar=%{javadir}/jsse/jnet.jar
jsse.jar=%{javadir}/jsse/jsse.jar
jmx.jar=%{javadir}/mx4j-jmx.jar
jmxri.jar=%{javadir}/mx4j-jmx.jar
junit.jar=%{javadir}/junit.jar
regexp.jar=%{javadir}/regexp-1.2.jar
servlet.jar=%{javadir}/servletapi4.jar
servlet.doc=%{javadocdir}/servletapi4
xercesImpl.jar=%{javadir}/jaxp_parser_impl.jar
xmlParserAPIs.jar=%{javadir}/xml-commons-apis.jar
puretls.jar=%{javadir}/puretls.jar
jmx.jar=%{javadir}/mx4j-jmx.jar
struts.jar=%{javadir}/struts.jar
struts.lib=%{_datadir}/struts
jdbc20ext.jar=%{javadir}/jdbc-stdext-2.0.jar
activation.jar=%{javadir}/activation.jar
mail.jar=%{javadir}/javamail/mailapi.jar
jndi.jar=%{javadir}/jndi.jar
jta.jar=%{javadir}/jta.jar
jaas.jar=%{javadir}/jaas.jar
tyrex.jar=%{javadir}/tyrex-1.0.jar
EOBP

# can't use jikes to build tomcat4 (strange)
export usejikes=false
ant -Djava.home=$JAVA_HOME 

# rename servletapi4.jar to servlet.jar (coyote need it)
mv build/common/lib/servletapi4.jar build/common/lib/servlet.jar


%install
# install RPM README
cp %{SOURCE3} .

export CLASSPATH=%{javadir}/xalan-j2.jar:%{javadir}/xml-commons-apis.jar

mkdir -p $RPM_BUILD_ROOT%{homedir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{sconfdir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

# sysv init and logging
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{name}
install %{SOURCE5} $RPM_BUILD_ROOT/%{sconfdir}/%{name}.conf

cd %{packdname}
export usejikes=false
ant -Djava.home=$JAVA_HOME dist 
mv dist/* $RPM_BUILD_ROOT%{homedir}

# create reloctomcat4
cat >> $RPM_BUILD_ROOT%{_bindir}/reloctomcat4<<EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC


install $RPM_BUILD_ROOT%{homedir}/bin/jspc.sh     $RPM_BUILD_ROOT%{_bindir}/jspc4

# rename catalina/jasper into dtomcat4/djasper4 to let wrapper take precedence
install $RPM_BUILD_ROOT%{homedir}/bin/jasper.sh   $RPM_BUILD_ROOT%{_bindir}/d%{jname}
install $RPM_BUILD_ROOT%{homedir}/bin/catalina.sh $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{homedir}/bin/catalina.sh.*

# install wrapper as tomcat4/jasper4
install %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{name}
install %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/%{jname}

# install logrotate support
install %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat
 
# FHS compliance patches, not easy to track them all boys :)

for i in $RPM_BUILD_ROOT%{sconfdir}/%{name}.conf $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{jname} $RPM_BUILD_ROOT%{_bindir}/%{jname} ; do

    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{sconfdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i

done

# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/servletapi4.jar

# rename to follow original jar names
%if %{use_dist} != strict
mv $RPM_BUILD_ROOT%{homedir}/common/lib/jdbc-stdext-2.0.jar $RPM_BUILD_ROOT%{homedir}/common/lib/jdbc2_0-stdext.jar
#mv $RPM_BUILD_ROOT%{homedir}/server/lib/mx4j-jmx.jar $RPM_BUILD_ROOT%{homedir}/server/lib/mx4j-jmx.jar
mv $RPM_BUILD_ROOT%{homedir}/server/lib/regexp-1.2.jar $RPM_BUILD_ROOT%{homedir}/server/lib/jakarta-regexp-1.2.jar
%endif

# remove some jars which will be linked at install time
# rpm guideline recommand to avoid duplicate.
%if %{use_dist} == light
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/jaxp_impl*.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/xml-commons*.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/endorsed/*.jar
# remove stuff which is present in JDK 1.4
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/activation.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/jdbc*-stdext.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/jndi.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/jta*.jar
rm -f $RPM_BUILD_ROOT%{homedir}/common/lib/*mail*.jar
rm -f $RPM_BUILD_ROOT%{homedir}/server/lib/jaas*.jar
%endif

%if %{use_dist} == full
# also recopy jndi.jar for JDK 1.2.x
cp %{javadir}/jndi.jar $RPM_BUILD_ROOT%{homedir}/common/lib/
%endif

%if %{use_dist} == strict
for i in %{extjars} %{admjars} %{mailjars}; do
  rm -f $RPM_BUILD_ROOT%{homedir}/$i
done         
%endif

%if %{use_fhs}

# Make FHS layout
mkdir -p ${RPM_BUILD_ROOT}%{confdir}
mkdir -p ${RPM_BUILD_ROOT}%{logdir}
mkdir -p ${RPM_BUILD_ROOT}%{workdir}
mkdir -p ${RPM_BUILD_ROOT}%{tempdir}

cd  ${RPM_BUILD_ROOT}%{homedir}
mv conf/* ${RPM_BUILD_ROOT}%{confdir}
rmdir conf
ln -s %{confdir} conf
rmdir logs
ln -s %{logdir} logs
rmdir work
ln -s %{workdir} work
# move README
mv temp/* ${RPM_BUILD_ROOT}%{tempdir}
rmdir temp
ln -s %{tempdir} temp

%endif

# fix mod_jk.jpeg (mine ;) which has been broken somewhere (cvs client ?)
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{appdir}/tomcat-docs/jk2/images/

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
# install tomcat4 (but don't activate)
/sbin/chkconfig --add %{name}
%if %{use_dist} == light
# install JAXP_PARSER
    if [ -r %{javadir}/jaxp_parser_impl.jar ]; then
        rm -f %{homedir}/common/endorsed/jaxp_parser*.jar
        ln -sf %{javadir}/jaxp_parser_impl.jar %{homedir}/common/endorsed/
        echo "symlinking %{javadir}/jaxp_parser_impl.jar to %{homedir}/common/endorsed/"
    else
        echo "couldn't find %{javadir}/jaxp_parser_impl.jar"
        echo "make sure to have a JAXP_PARSER RPM installed and make a symlink :"
        echo "ln -s %{javadir}/jaxp_parser.jar %{homedir}/common/endorsed/"
    fi
# install JAXP_APIS (from xml-commons-apis)
    if [ -r %{javadir}/xml-commons-apis.jar ]; then
        rm -f %{homedir}/common/endorsed/xml-commons-apis.jar
        ln -sf %{javadir}/xml-commons-apis.jar %{homedir}/common/endorsed/
        echo "symlinking %{javadir}/xml-commons-apis.jar to %{homedir}/common/endorsed/"
    else
        echo "couldn't find %{javadir}/xml-commons-apis.jar"
        echo "make sure to have  xml-commons-apis RPM installed and make a symlink :"
        echo "ln -s %{javadir}/xml-commons-apis.jar %{homedir}/common/endorsed/"
    fi
%endif

%if %{use_dist} == strict
for i in %{extjars}; do
  jar=`basename $i`
  if [ -r %{javadir}/$jar ]; then
	rm -f %{homedir}/$jar
	ln -sf %{javadir}/$jar %{homedir}/$i
	echo "symlinking %{javadir}/$jar to %{homedir}/$i"
  else
    echo "couldn't find %{javadir}/$jar"
	echo "make sure to have the corresponding rpm package installed and make a symlink :"
	echo "ln -s %{javadir}/$jar %{homedir}/$i" 
  fi
done

# handle mail jars
for i in %{mailjars}; do
	jar=`basename $i`
	if [ -r %{javadir}/javamail/$jar ]; then
	   rm -f %{homedir}/$jar
	   ln -sf %{javadir}/javamail/$jar %{homedir}/$i
       echo "symlinking %{javadir}/$jar to %{homedir}/$i"
    else
      echo "couldn't find %{javadir}/javamail/$jar"
      echo "make sure to have the corresponding rpm package installed and make a symlink :"
      echo "ln -s %{javadir}/javamail/$jar %{homedir}/$i"
    fi
done
%endif

echo ""
echo "Don't forget to setup vars in %{sconfdir}/%{name}.conf to"
echo "adapt the RPM to your configuration."
echo "Also edit/create /etc/java/java.conf to define your default JDK"
echo ""
echo "For security purposes, %{name} service is installed" 
echo "but not activated by default."
echo "use your service installer for such purposes"
echo "ie: ntsysv "
echo ""

%post admin-webapps
%if %{use_dist} == strict
for i in %{admjars}; do
  jar=`basename $i`
  if [ -r %{javadir}/$jar ]; then
        rm -f %{homedir}/$jar
        cp %{javadir}/$jar %{homedir}/$i
        echo "copying %{javadir}/$jar to %{homedir}/$i"
  else
        echo "couldn't find %{javadir}/$jar"
        echo "make sure to have the corresponding rpm package installed and make a symlink :"
        echo "cp %{javadir}/$jar %{homedir}/$i"
  fi
done
%endif

%preun
if [ $1 = 0 ]; then
    if [ -f /var/lock/subsys/%{name} ]; then
        %{_sysconfdir}/rc.d/init.d/%{name} stop
    fi
    if [ -f %{_sysconfdir}/rc.d/init.d/%{name} ]; then
        /sbin/chkconfig --del %{name}
    fi
%if %{use_dist} == light
    # remove linked jars
    rm -f %{homedir}/common/endorsed/jaxp_parser_impl.jar
    rm -f %{homedir}/common/endorsed/xml-commons-apis.jar
%endif

%if %{use_dist} == strict
for i in %{extjars}; do
  rm -f %{homedir}/$i
done
%endif

    %{_sbindir}/userdel %{name}
fi

%preun admin-webapps
%if %{use_dist} == strict
for i in %{admjars}; do
  rm -f %{homedir}/$i
done
%endif

%pre
# Add the "tomcat" user
# we need a shell to be able to use su - later
%{_sbindir}/useradd -c "Tomcat4" -u %{tcuid} \
    -s /bin/bash -r -d %{homedir} %{name} 2> /dev/null || :


%files
%defattr(644 root root 755)
%attr(770,root,tomcat4)		%dir                  %{appdir}
%attr(755,root,root)      	%dir                  %{bindir}
%attr(755,root,root)      	%dir                  %{commondir}
%if ! %{use_fhs}
%attr(775,root,tomcat4)    	%dir                  %{confdir}
%endif
%attr(775,root,tomcat4)    	%dir                  %{sconfdir}
%attr(755,tomcat4,tomcat4)  %dir                  %{logdir}
%attr(755,root,root)      	%dir                  %{servdir}
%attr(755,root,root)      	%dir                  %{shareddir}
%attr(775,root,tomcat4)    	%dir                  %{tempdir}
%attr(775,root,tomcat4)    	%dir                  %{workdir}
%if ! %{use_fhs}
%attr(644,root,root)      	%config(noreplace)    %{sconfdir}/%{name}.conf
%endif
%attr(755,root,root) 	  	%{_bindir}/*
%attr(644,root,root)       	%{bindir}/*
%attr( - ,root,root)       	%{commondir}/*
%attr(644,root,tomcat4)    	%config(noreplace)      %{confdir}/catalina.policy
%attr(660,root,tomcat4)    	%config(noreplace)      %{confdir}/jk2.properties
%attr(660,root,tomcat4)    	%config(noreplace)      %{confdir}/tomcat-users.xml
%attr(644,root,tomcat4)    	%config(noreplace)      %{confdir}/tomcat4.conf
%attr(644,root,tomcat4)    	%config(noreplace)      %{confdir}/server.xml
%attr(644,root,tomcat4)  							%{confdir}/server-noexamples.xml.config
%attr(644,root,tomcat4)    	%config(noreplace)      %{confdir}/web.xml
%attr( - ,root,root)       	                    	%{servdir}/classes/
%attr( - ,root,root)                            	%{servdir}/lib/*
%attr( - ,root,root)                            	%{shareddir}/classes/
%if %{use_fhs}
%attr(755,root,root)								%{homedir}/conf
%attr(775,root,tomcat4)								%{homedir}/logs
%attr(775,root,tomcat4)								%{homedir}/temp
%attr(775,root,tomcat4)								%{homedir}/work
%endif
%attr( -, root,root)                            	%{_sysconfdir}/logrotate.d/%{name}
%attr(755,root,root)  	  	%config 	        	%{_sysconfdir}/rc.d/init.d/%{name}
%attr( - ,root,root)  	  	%doc 		        	TOMCAT4.README.RPM %{packdname}/{LICENSE,README*,RELE*}

%files webapps
%defattr(640 root tomcat4 770)
%attr( - ,root,tomcat4) %{appdir}/examples/*
%attr( - ,root,tomcat4) %{appdir}/ROOT/*
%attr( - ,root,tomcat4) %{appdir}/tomcat-docs/*
%attr( - ,root,tomcat4) %{appdir}/webdav/*

%files admin-webapps
%defattr(640 root tomcat4 750)
%attr( - ,root,tomcat4) %{appdir}/admin.xml
%attr( - ,root,tomcat4) %{appdir}/manager.xml
%attr( - ,root,tomcat4) %{servdir}/webapps/*

%changelog
* Fri Mar 28 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.24-2jpp
- 4.1.24 
- use javamail instead of old monolithic javamail
 
* Wed Mar 19 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.24-1jpp
- 4.1.24 alpha

* Tue Mar 18 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.23-1jpp
- 4.1.23 alpha
- complete release include commons-fileupload-1.0-beta1

* Fri Mar 14 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.22-3jpp
- fix init script

* Wed Mar 12 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.22-2jpp
- rpm release 2
- init script control now that tomcat isn't allready running at start
- don't remove run/lock if tomcat stop failed in init script stop 

* Mon Mar 10 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.22-1jpp
- 4.1.22 alpha

* Thu Mar 06 2003 Henri Gomez <hgomez@@users.sourceforge.net> 4.1.21-2jpp
- 4.1.21 beta
- rpm release 2
- improved tomcat script which will store main java process in file
  pointed by CATALINA_PID env var if existing, and will kill tomcat if
  it didn't stop after SHUTDOWN_WAIT seconds (tomcat4.conf)

* Wed Feb 26 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.21-1jpp
- 4.1.21 alpha
- use mx4j 1.1.1 for which jar changed from mx4j.jar to mx4j-jmx.jar

* Thu Feb 13 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.20-1jpp
- 4.1.20 alpha
- full version bundled with update beanutils 1.6

* Fri Jan 24 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-2jpp
- rpm release 2
- fix rights on tomcat-users.xml and jk2.properties, only root and tomcat4
  user could update it (reported by Boris Folgmann)

* Wed Jan 15 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-1jpp
- 4.1.19 alpha
- new requirement, commons-fileupload

* Fri Dec 20 2002 Ville Skytt <ville.skytta at iki.fi> - 4.1.18-1jpp
- 4.1.18 stable, security update release.

* Wed Dec 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.17-1jpp
- 4.1.17 stable release

* Wed Dec 03 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 beta release

* Wed Nov 27 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 alpha release

* Tue Nov 19 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.15-1jpp
- 4.1.15 release

* Tue Oct 29 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-3jpp
- rpm release 3
- relax perms in webapps, tomcat4 could now write in it and as
  suck will be able to autoexpand wars.

* Mon Oct 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-2jpp
- rpm release 2
- fix tomcat4.conf to use /etc/java/java.conf
- fix tomcat4 initd to be sure that we'll stop/start the task owner by 
  TOMCAT_USER and running catalina
- fix perms on %{confdir}, contents is owned by root.tomcat4, and only
  jk2.properties and tomcat-users.xml could be updated by tomcat4 user.
- change ref and use of xerces-j2.jar by jaxp_parser_impl.jar.
- include ant 1.5.1
- remove commons-lang as no more required
- copy a correct mod_jk.jpeg 

* Mon Sep 30 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-1jpp
- 4.1.12 release
- include commons-logging 1.0.2, xerces-j2 2.1.0
- warning: do not use xerces-j2 2.2.0 which cause strange parse exception
  making Tomcat 4.1.12 to fail at startup

* Mon Sep 16 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-4jpp
- rpm release 4
- fixed java.conf location in misc documents and messages

* Fri Sep 13 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-3jpp
- rpm release 3
- fix TOMCAT4.README.RPM documentation

* Fri Sep 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-2jpp
- rpm release 2
- fix java.conf location
- webapps are owned by root:tomcat4 750/640
- fix initd script to ensure using pidof catalina

* Mon Sep 09 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-1jpp
- 4.1.10 release
- jasper jars moved from shared/lib to common/lib
- full version bundled with latest release of :
  javamail 1.3, jaf 1.0.2, beanutils 1.4.1, commons-pool 1.0.1

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-4jpp
- rpm release 4
- Requires jta-1.0.1a 

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-3jpp
- rpm release 3
- the rpm could be now built in 3 modes :
  ligth, follow jakarta LE tarball, ie didn't include stuff present in JDK 1.4
  full,  follow jakarta FULL tarball, ie include everything needed
  strict, include only tomcat stuff, requires all others to be allready present
  (jakarta-commons-*, regexp, serlvet-2.3...)
- commons-logging, regexp and servlet jars should be also included in LE mode
- TOMCAT4.README.RPM updated
- copy struts.jar in admin-webapp since symlinking it make admin webapp failed !

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-2jpp
- rpm release 2
- fix jasper4 and jspc4 scripts
- set Vendor and Distribution tags to JPackage
- add JSSE if found in usual JPackage location (%{javadir})
 
* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-1jpp
- 4.1.9
- add commons-lang to required package for build
- make use of commons-logging 1.0.1
- remove the ugly hack in start/stop

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-2jpp
- rpm release 2
- fix jdbcext jar name
- use jakarta-commons-logging 1.0.1 release package
- use jpackage-utils in tomcat4.conf and correct /etc/java.conf check

* Wed Jul 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-1jpp
- tomcat 4.1.7
- take care of new jaxp apis/impl policy
- update build since jsse is now under javadir/jsse
- new package, admin-webapps
- tomcat4 need write access to the conf dir, so the dir is owned by tomcat4

* Wed Jun 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-2jpp
- rpm release 2
- change build order : jtc/util, tc4, jtc/coyote, jtc/jk
- the rpm requires that you define your system Java SDK in /etc/java.conf
  or %{sconfdir}/%{name}.conf (at least define JAVA_HOME)
  Take a look at TOMCAT4.README.RPM for more explanations
- layout changes to meet FHS recommandations :
- use /var/cache/tomcat4 instead of /var/run/tomcat4/{work,temp}
- moved conf from /etc/tomcat4/conf to /etc/tomcat4
- logs/work/temp and webapps now owned by tomcat4 user
- fix regexp name and location

* Mon Jun 24 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-1jpp
- tomcat-v4.0.4
%if %{use_dist} == light
- this rpm is equivalent to jakarta-tomcat-4.0.4-LE-jdk14.
%else
- this rpm is equivalent to jakarta-tomcat-4.0.4 full.
%endif
- tomcat4 is more FHS compliant, using symlinks to homedir
- tomcat4 use standard port, relocation command reloctomcat4 is 
  provided to make it listen to alternate ports to make it 
  compatible with a present tomcat 3.3
- unique rpm for both jpackage.org and jakarta.org
- commons-logging is the one from packager site until an official 1.0.1
  release will be out
- Take a look at TOMCAT4.README.RPM for more informations about RPM

* Tue Apr 30 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.4-b2
- correct postun script, remove linked jars after service stop

* Fri Apr 26 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3 rpm release 2
- misc spec/rpm fixes.

* Mon Mar 04 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3
- security fix
- add symlinking info at post time

* Tue Feb 19 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 3
- correct missing tools.jar in CLASSPATH in both tomcat4 and jasper4

* Fri Feb 15 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 2
- correct bad perms for webapps dir
- warn user at install time if ext jars are not found
- use new tarball for JTC (jakarta-tomcat-connectors-4.0.2-01-src)

* Mon Feb 11 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2
- rpm use the light distribution mode whereas jndi, javamail, jta and jdbc-ext
  are not required.
- rpm now is fully rpm compliant, jakarta-regexp, servletapi4, xerces rpm are 
  required for build and should be present, they will be linked at install time.

* Wed Jan 23 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2-b2
- removed tomcat 4.0.2-b2 binary tarball to save place in srpm
- removed manual package, stuff will be only in webapps
- due to Sun Licence we couldn't provide jaf, javamail, jdbc-ext, jmxri, jndi, jta 
  jars in source package, so the build dependencies will require to have them 
  ALLREADY present in %{javadir}.
- rpm 4.0.3 have problem with _ in dependencies, jdbcext/jta buildrequire has
  been commented BUT are needed 

* Fri Oct 24 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.1
- ajp13 support is now included by default in Tomcat 4.0, so I've included
  stuff from jakarta-tomcat-connectors CVS (20011023) to rebuild ajp connector
  from source
- since you could have also a tomcat 3.x running, listen port in Tomcat 4.0
  rpm have been translated :
  HTTP 1.1 from 8080 to 8180, Proxied HTTP 1.1 from 8081 to 8181,
  HTTP 1.1/SSL from 8443 to 8543 and AJP13 from 8009 to 8109
  HTTP 1.0 from port 8082 to 8182
  if you want to use original values, edit file %{homedir}/conf/server.xml
- connectors activated by default are HTTP 1.1, WARP and AJP13
- rework RPM to have tomcat4 works under user tomcat4 (like tomcat 3.3 RPM)
- fix images corruptions

* Mon Oct 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0
- to avoid license problem both source and binary are included in the source rpm
  we use binary tarball to get required jar, jndi, mail, jta...
- Java Managment Extension, jmx is included in source rpm for build purpose but
  won't be installed in binary rpm again for license problem.
- many RPM enhancements from suggestion from Keith Irwin <keith_irwin@non.hp.com>,
  Nicolas Mailhot <nicolas.mailhot@one2team.com> and Jun Inamori. A big thanks
  to all of them
- tomcat run as nobody (finally) in init.d.
  BE CAREFULL NOW WHEN running tomcat as root (in interactive mode for example)
  since you could then make some files unreadable
- a config file is available for init.d script tuning, tomcat.conf, in %{confdir}
- no external parser is required since crimson (jaxp 1.1) is now included
- this RPM is still not FHS, need some reworks...
- no external parser is required since crimson (jaxp 1.1) is now included
- built under Redhat 6.2 with updates, jikes 1.15, ant 1.4, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Thu Sep 13 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0-rc1
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Tue Jun 05 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b5
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010502), jsse 1.0.2
- included xerces 1.4.0 

* Fri May 11 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b4

* Wed Apr 18 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b3

* Mon Apr 02 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b2
- second beta release of tomcat 4
- big cleanup of the SPEC which was just to complex.
- Need now a jaxp 1.1 conforming parser, => require xerces-j 1.3.1
- removed jaxp 1.0 / 1.1 from SPEC since we're using xerces-j 1.3.1
  (jaxp 1.1 / crimson is include in tomcat sources)
- YOU MUST HAVE the JSSE 1.0.2 jars in /usr/share/java (I've built a
  jsse RPM from Sun Jars but I COULD'T MAKE IT AVAILABLE...)

* Mon Jan 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b1
- first beta release of tomcat 4

* Thu Dec 14 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m5

* Thu Nov 02 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m4

* Tue Oct 24 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3 RPM Release 2
- corrected jars included 
- we assume you've installed jsse jars in /usr/share/java
- renamed tomcat4-doc to tomcat4-manual (follow apache RPM naming)
- RH 7.0 changes location of docdir and DocumentRoot. The spec file is modified
  to place manual in right place when rebuilded under RH 6.x or RH 7.0
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5
- build CLASSPATH=

* Thu Oct 19 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3

* Tue Oct 17 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m2 RPM Release 2
- follow Debian policy about java stuff, libs in /usr/share/java,
  executable in /usr/bin, apps datas in %{homedir}
- prepare transition to RH 7.0 new document root (/var/www)
- build CLASSPATH=/usr/share/java/jsse.jar:/usr/share/java/jcert.jar:/usr/share/java/jnet.jar

* Thu Oct 12 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m2 
- to allow tomcat 3.x and tomcat 4.x coexistence, the RPM is named tomcat4.
  It start at version 4.0 and all datas will goes in /home/tomcat4.
- tomcat 4.0 need ant post 1.1, xerces 1.2.0, jsse 1.0.1 (min) and jmx.
  The RPM include ant post 1.1 (for build) and jmx (jmxri.jar for build/run) .
  I couldn't include JSSE stuff so you must download JSSE from java.sun.com.
  Next install jcert.jar, jnet.jar and jsse.jar in BOTH
  /usr/lib/java AND JAVA_HOME/jre/lib/ext
- TC 4.0 HTTP 1.1 connector moved from port 8080 to 8180 and
  from port 8081 to 8181 for HTTP 1.0 connector 
  (TC 3.x allready listen on 8080/8081)
 
* Sat Oct 07 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m1
- RPM never released

* Fri Oct 06 2000 Henri Gomez <hgomez@users.sourceforge.net>
- RPM release 2
- tomcat is now installed on /home/tomcat instead of
  /opt/tomcat since /opt is mounted read-only on
  many systems <summer@os2.ami.com.au>
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar
- correct stuff in spec file (copyright, group...)

* Mon Sep 25 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v3.2-beta-5 RPM
- detect jikes and use it to rebuild (yep 10 times faster).
- patched incorrect version number
- rebuilded with jikes 1.12 (and jsse 1.0.2).
